--Drastically increases availability of item pickups
--Extracted from KLV_Diamond, originally written by Fuckal

local itemboxspawnmod = CV_RegisterVar({
    name = "wa_itemboxspawnmod",
    defaultvalue = "On",
    flags = CV_NETVAR,
    PossibleValue = CV_OnOff
})

local function getPlayercount()
	local g = 0;
	for p in players.iterate
		if p.valid and p.mo and p.mo.valid
			g = $1 + 1;
		end
	end
	return g;
end

local function K_GiveItem(thing, other)
	if not itemboxspawnmod.value then return end
	if (cv_dorings) and (cv_dorings == 1) then return end --Not getting rings from item boxes with this on
	local pct = getPlayercount()
	if pct < 16 then return end --Disable this if playercount is under 16
	if (other.player and not other.player.spectator) then
		if (P_CanPickupItem(other.player, 1) and (not thing.boxdelay)) then
			local cv_itemrespawntime = CV_FindVar("respawnitemtime");
			local RESPAWNTIME = cv_itemrespawntime.value*TICRATE;
			
			other.player.kartstuff[k_itemroulette] = 1;
			
			-- reduce delay based on how many players are present
			
			-- huge lobbies often mean that players barely get items in general,
			-- leading to losing players getting swamped with defense items
			-- so, let's reduce the delay for item boxes
			
			-- upper management demands it to be "instant"
			thing.boxdelay = 2; //max(6, min(RESPAWNTIME, RESPAWNTIME - ((TICRATE/8)* max(0, pct - 2) )  )) -- Time until item box respawn in tics			
			
			pct = nil;
			
			// item explosion
			local explode = mobjinfo[thing.info.damage].mass;
			
			
			local remains = P_SpawnMobj(thing.x, thing.y,
				((thing.eflags & MFE_VERTICALFLIP) and (thing.z + 3*(thing.height/4) - FixedMul(mobjinfo[explode].height, thing.scale)) or (thing.z + thing.height/4)), explode);	
			if (thing.eflags & MFE_VERTICALFLIP)
				remains.eflags = ($ | MFE_VERTICALFLIP);
				remains.flags2 = ($ | MF2_OBJECTFLIP);
			end
				
			remains.destscale = thing.destscale;
			P_SetScale(remains, thing.scale);

			remains = P_SpawnMobj(thing.x, thing.y, thing.z, thing.info.damage);
			
			S_StartSound(remains, thing.info.deathsound);
			
			return false -- "Kill" item box
		end
	end
	return true -- Do nothing
end -- Close function

local function hideItemBox(mo)
	if not itemboxspawnmod.value then return end
	if mo and mo.valid and mo.boxdelay
		if (mo.boxdelay > 1)
			mo.state = S_INVISIBLE;
		else
			mo.state = S_RANDOMITEM1;
		end
		
		mo.boxdelay = $ - 1;
	end
end

addHook("TouchSpecial",	K_GiveItem,	MT_RANDOMITEM);
addHook("MobjThinker", hideItemBox, MT_RANDOMITEM);